/*
 * Copyright (C) 2005-2009 Makoto Sato. All Rights Reserved.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
package jp.objectfanatics.assertion.weaver.api.core.exception.info;

//Checked 09.26.2009. Delete this line before release.
/**
 * Constructor or method parameter information.
 * 
 * @author Makoto Sato
 */
public interface ParameterInfo {
	
	/**
	 * Returns parameter index.
	 * 
	 * @return parameter index
	 */
	int getIndex();
	
	/**
	 * Returns parameter name.
	 * 
	 * @return parameter name
	 * @throws ParameterNameNotAvailableException
	 *             if parameter name is not available
	 */
	String getName() throws ParameterNameNotAvailableException;
	
	/**
	 * Returns type information.
	 * 
	 * @return type information
	 */
	TypeInfo getType();
	
	/**
	 * Signals that parameter name is not available.
	 */
	public static class ParameterNameNotAvailableException extends Exception {}
}
