package jp.objectfanatics.assertion.weaver.impl.annotationprocessor.numbercomparing.assertionconditiongenerator;

import static jp.objectfanatics.commons.javassist.JavassistUtils.isBigInteger;
import javassist.CtBehavior;
import javassist.CtClass;
import jp.objectfanatics.assertion.weaver.impl.annotationprocessor.numbercomparing.AbstractNumberComparingAssertionWeaver.ThresholdOutOfBoundsException;

public class BigIntegerAssertionConditionExpressionGenerator extends ThresholdValidatableComparableNumberAssertionConditionExpressionGeneratorBase {

	public BigIntegerAssertionConditionExpressionGenerator(String comparativeOperator, Class<? extends java.lang.annotation.Annotation> targetConstraintAnnotation) {
		super(comparativeOperator, targetConstraintAnnotation);
	}

	@Override
	protected String doGetAssertionTargetValueExpression(CtBehavior ctBehavior, CtClass type, String valueIdentifier, double threshold) throws ThresholdOutOfBoundsException {
// TODO:昔のコードが、なぜか下記のように double にキャストしていたのだが、理由が思い出せないし、意味がなさそうなので、とりあえずはずした。ということで、問題がないという裏をとりましょう。
//		return valueIdentifier + ".longValue() " + comparativeOperator + " (double)" + threshold;
		return valueIdentifier + ".longValue()";
	}
	
	@Override
	public boolean isSupported(CtClass type) {
		return isBigInteger(type);
	}

	protected String getLowerLimitDesc() {
		return "Long.MIN_VALUE[=" + Long.MIN_VALUE + "]";
	}

	protected String getUpperLimitDesc() {
		return "Long.MAX_VALUE[=" + Long.MAX_VALUE + "]";
	}

	protected boolean isSmaller(double threshold) {
		return threshold < Long.MIN_VALUE;
	}

	protected boolean isLarger(double threshold) {
		return threshold > Long.MAX_VALUE;
	}
}
