package jp.objectfanatics.assertion.weaver.impl.annotationprocessor.numbercomparing.assertionconditiongenerator;

import static jp.objectfanatics.commons.javassist.JavassistUtils.isByte;
import static jp.objectfanatics.commons.javassist.JavassistUtils.isPrimitiveByte;
import javassist.CtBehavior;
import javassist.CtClass;
import jp.objectfanatics.assertion.weaver.impl.annotationprocessor.numbercomparing.AbstractNumberComparingAssertionWeaver.ThresholdOutOfBoundsException;

public class ByteAssertionConditionExpressionGenerator extends ThresholdValidatableComparableNumberAssertionConditionExpressionGeneratorBase {

	public ByteAssertionConditionExpressionGenerator(String comparativeOperator, Class<? extends java.lang.annotation.Annotation> targetConstraintAnnotation) {
		super(comparativeOperator, targetConstraintAnnotation);
	}
	
	@Override
	protected String doGetAssertionTargetValueExpression(CtBehavior ctBehavior, CtClass type, String valueIdentifier, double threshold) throws ThresholdOutOfBoundsException {
		return "new Byte(\"\"+" + valueIdentifier + ").byteValue()";
	}

	@Override
	public boolean isSupported(CtClass type) {
		return isByte(type) || isPrimitiveByte(type);
	}

	protected String getLowerLimitDesc() {
		return "Byte.MIN_VALUE[=" + Byte.MIN_VALUE + "]";
	}

	protected String getUpperLimitDesc() {
		return "Byte.MAX_VALUE[=" + Byte.MAX_VALUE + "]";
	}

	protected boolean isSmaller(double threshold) {
		return threshold < Byte.MIN_VALUE;
	}

	protected boolean isLarger(double threshold) {
		return threshold > Byte.MAX_VALUE;
	}
	
}
