package jp.objectfanatics.assertion.weaver.impl.annotationprocessor.numbercomparing.assertionconditiongenerator;

import javassist.CtBehavior;
import javassist.CtClass;
import jp.objectfanatics.assertion.weaver.impl.annotationprocessor.numbercomparing.AbstractNumberComparingAssertionWeaver.ThresholdOutOfBoundsException;

public abstract class ComparableNumberAssertionConditionExpressionGeneratorBase implements ComparableNumberAssertionConditionExpressionGenerator {

	protected final String comparativeOperator;
	protected final Class<? extends java.lang.annotation.Annotation> targetConstraintAnnotation;

	public ComparableNumberAssertionConditionExpressionGeneratorBase(String comparativeOperator, Class<? extends java.lang.annotation.Annotation> targetConstraintAnnotation) {
		// TODO: assert
		this.comparativeOperator = comparativeOperator;
		this.targetConstraintAnnotation = targetConstraintAnnotation;
	}

	public final String getAssertionErrorConditionExpression(CtBehavior ctBehavior, CtClass type, String valueIdentifier, double threshold) throws ThresholdOutOfBoundsException, NotSupportedException {
		if (isSupported(type)) {
			return getAssertionTargetValueExpression(ctBehavior, type, valueIdentifier, threshold) + comparativeOperator + threshold;
		}
		throw new NotSupportedException();
	}

	protected abstract String getAssertionTargetValueExpression(CtBehavior ctBehavior, CtClass type, String valueIdentifier, double threshold) throws ThresholdOutOfBoundsException;
}
