package jp.objectfanatics.assertion.weaver.impl.annotationprocessor.numbercomparing.assertionconditiongenerator;

import static jp.objectfanatics.commons.javassist.JavassistUtils.isDouble;
import static jp.objectfanatics.commons.javassist.JavassistUtils.isPrimitiveDouble;
import javassist.CtBehavior;
import javassist.CtClass;
import jp.objectfanatics.assertion.weaver.impl.annotationprocessor.numbercomparing.AbstractNumberComparingAssertionWeaver.ThresholdOutOfBoundsException;

public class DoubleAssertionConditionExpressionGenerator extends ComparableNumberAssertionConditionExpressionGeneratorBase {

	public DoubleAssertionConditionExpressionGenerator(String comparativeOperator, Class<? extends java.lang.annotation.Annotation> targetConstraintAnnotation) {
		super(comparativeOperator, targetConstraintAnnotation);
	}
	
	@Override
	protected String getAssertionTargetValueExpression(CtBehavior ctBehavior, CtClass type, String valueIdentifier, double threshold) throws ThresholdOutOfBoundsException {
		return "new Double(\"\"+" + valueIdentifier + ").doubleValue()";
	}

	@Override
	public boolean isSupported(CtClass type) {
		return isDouble(type) || isPrimitiveDouble(type);
	}
}
