package jp.objectfanatics.assertion.weaver.impl.annotationprocessor.numbercomparing.assertionconditiongenerator;

import static jp.objectfanatics.commons.javassist.JavassistUtils.isFloat;
import static jp.objectfanatics.commons.javassist.JavassistUtils.isPrimitiveFloat;
import javassist.CtBehavior;
import javassist.CtClass;
import jp.objectfanatics.assertion.weaver.impl.annotationprocessor.numbercomparing.AbstractNumberComparingAssertionWeaver.ThresholdOutOfBoundsException;

public class FloatAssertionConditionExpressionGenerator extends ThresholdValidatableComparableNumberAssertionConditionExpressionGeneratorBase {

	public FloatAssertionConditionExpressionGenerator(String comparativeOperator, Class<? extends java.lang.annotation.Annotation> targetConstraintAnnotation) {
		super(comparativeOperator, targetConstraintAnnotation);
	}
	
	@Override
	protected String doGetAssertionTargetValueExpression(CtBehavior ctBehavior, CtClass type, String valueIdentifier, double threshold) throws ThresholdOutOfBoundsException {
		return "new Float(\"\"+" + valueIdentifier + ").floatValue()";
	}

	@Override
	public boolean isSupported(CtClass type) {
		return isFloat(type) || isPrimitiveFloat(type);
	}

	protected String getLowerLimitDesc() {
		return "-Float.MAX_VALUE[=" + (-Float.MAX_VALUE) + "]";
	}

	protected String getUpperLimitDesc() {
		return "Float.MAX_VALUE[=" + Float.MAX_VALUE + "]";
	}

	protected boolean isSmaller(double threshold) {
		return threshold < -Float.MAX_VALUE;
	}

	protected boolean isLarger(double threshold) {
		return threshold > Float.MAX_VALUE;
	}
}
