package jp.objectfanatics.assertion.weaver.impl.annotationprocessor.numbercomparing.assertionconditiongenerator;

import static jp.objectfanatics.commons.javassist.JavassistUtils.isAtomicInteger;
import static jp.objectfanatics.commons.javassist.JavassistUtils.isInteger;
import static jp.objectfanatics.commons.javassist.JavassistUtils.isPrimitiveInt;
import javassist.CtBehavior;
import javassist.CtClass;
import jp.objectfanatics.assertion.weaver.impl.annotationprocessor.numbercomparing.AbstractNumberComparingAssertionWeaver.ThresholdOutOfBoundsException;

public class IntegerAssertionConditionExpressionGenerator extends ThresholdValidatableComparableNumberAssertionConditionExpressionGeneratorBase {

	public IntegerAssertionConditionExpressionGenerator(String comparativeOperator, Class<? extends java.lang.annotation.Annotation> targetConstraintAnnotation) {
		super(comparativeOperator, targetConstraintAnnotation);
	}

	@Override
	protected String doGetAssertionTargetValueExpression(CtBehavior ctBehavior, CtClass type, String valueIdentifier, double threshold) throws ThresholdOutOfBoundsException {
		return "new Integer(\"\"+" + valueIdentifier + ").intValue()";
	}
	
	@Override
	public boolean isSupported(CtClass type) {
		return isPrimitiveInt(type) || isInteger(type) || isAtomicInteger(type);
	}

	protected String getLowerLimitDesc() {
		return "Integer.MIN_VALUE[=" + Integer.MIN_VALUE + "]";
	}

	protected String getUpperLimitDesc() {
		return "Integer.MAX_VALUE[=" + Integer.MAX_VALUE + "]";
	}

	protected boolean isSmaller(double threshold) {
		return threshold < Integer.MIN_VALUE;
	}

	protected boolean isLarger(double threshold) {
		return threshold > Integer.MAX_VALUE;
	}
}
