package jp.objectfanatics.assertion.weaver.impl.annotationprocessor.numbercomparing.assertionconditiongenerator;

import static jp.objectfanatics.commons.javassist.JavassistUtils.isAtomicLong;
import static jp.objectfanatics.commons.javassist.JavassistUtils.isLong;
import static jp.objectfanatics.commons.javassist.JavassistUtils.isPrimitiveLong;
import javassist.CtBehavior;
import javassist.CtClass;
import jp.objectfanatics.assertion.weaver.impl.annotationprocessor.numbercomparing.AbstractNumberComparingAssertionWeaver.ThresholdOutOfBoundsException;

public class LongAssertionConditionExpressionGenerator extends ThresholdValidatableComparableNumberAssertionConditionExpressionGeneratorBase {

	public LongAssertionConditionExpressionGenerator(String comparativeOperator, Class<? extends java.lang.annotation.Annotation> targetConstraintAnnotation) {
		super(comparativeOperator, targetConstraintAnnotation);
	}

	@Override
	protected String doGetAssertionTargetValueExpression(CtBehavior ctBehavior, CtClass type, String valueIdentifier, double threshold) throws ThresholdOutOfBoundsException {
		return "new Long(\"\"+" + valueIdentifier + ").longValue()";
	}

	@Override
	public boolean isSupported(CtClass type) {
		return isPrimitiveLong(type) || isLong(type) || isAtomicLong(type);
	}

	protected String getLowerLimitDesc() {
		return "Long.MIN_VALUE[=" + Long.MIN_VALUE + "]";
	}

	protected String getUpperLimitDesc() {
		return "Long.MAX_VALUE[=" + Long.MAX_VALUE + "]";
	}

	protected boolean isSmaller(double threshold) {
		return threshold < Long.MIN_VALUE;
	}

	protected boolean isLarger(double threshold) {
		return threshold > Long.MAX_VALUE;
	}
}
