package jp.objectfanatics.assertion.weaver.impl.annotationprocessor.numbercomparing.assertionconditiongenerator;

import static jp.objectfanatics.commons.javassist.JavassistUtils.isPrimitiveShort;
import static jp.objectfanatics.commons.javassist.JavassistUtils.isShort;
import javassist.CtBehavior;
import javassist.CtClass;
import jp.objectfanatics.assertion.weaver.impl.annotationprocessor.numbercomparing.AbstractNumberComparingAssertionWeaver.ThresholdOutOfBoundsException;

public class ShortAssertionConditionExpressionGenerator extends ThresholdValidatableComparableNumberAssertionConditionExpressionGeneratorBase {
	
	public ShortAssertionConditionExpressionGenerator(String comparativeOperator, Class<? extends java.lang.annotation.Annotation> targetConstraintAnnotation) {
		super(comparativeOperator, targetConstraintAnnotation);
	}

	@Override
	protected String doGetAssertionTargetValueExpression(CtBehavior ctBehavior, CtClass type, String valueIdentifier, double threshold) throws ThresholdOutOfBoundsException {
		return "new Short(\"\"+" + valueIdentifier + ").shortValue()";
	}

	@Override
	public boolean isSupported(CtClass type) {
		return isShort(type) || isPrimitiveShort(type);
	}

	protected String getLowerLimitDesc() {
		return "Short.MIN_VALUE[=" + Short.MIN_VALUE + "]";
	}

	protected String getUpperLimitDesc() {
		return "Short.MAX_VALUE[=" + Short.MAX_VALUE + "]";
	}

	protected boolean isSmaller(double threshold) {
		return threshold < Short.MIN_VALUE;
	}

	protected boolean isLarger(double threshold) {
		return threshold > Short.MAX_VALUE;
	}
}
